// cl du.c graphics.lib
#include <stdio.h>
#include <graph.h>
#include <dos.h>
#include <signal.h>
#include "\gwl\gwlib.h"
#include "\rs232c\rs232c.h"

#define D_SIZE	300		/* ctӂ̒	*/
#define	C_X	420		/* ctS@wW	*/
#define	C_Y	200		/* @@@@@xW	*/

#define	B_SIZE	(D_SIZE/10/2)	/* x[XCb`̈ӂ̒̂P^Q	*/
#define	R_SIZE	(D_SIZE/18/2)	/* bJXCb`̏cӂ̒̂P^Q	*/
#define	D_B_KAN (D_SIZE/20)	/* x[XCb`Ƃct̊Ԋu		*/
#define	R_KAN 	(D_SIZE/50)	/* bJXCb`̊Ԋu			*/
#define	B_KAN   (D_SIZE/7)	/* x[XCb`̊Ԋu			*/
				/* ctSx[XCb`S̋ */
#define	B_POS	(D_SIZE/2 + D_B_KAN + B_SIZE/2)

static	void	m_int(union REGS *);

					/* x[CbJXCb`  */
struct	bezel_xy {
	int x1;				/* ̍W@(x1,y1) */
	int y1;	
	int x2;				/* E̍W@(x2,y2) */
	int y2;
	int byte;			/* c^t||r^f@*/ 
	int bit;			/*       tH[}bg  */ 
};
typedef	struct bezel_xy POS_XY;

static	POS_XY bezel[] = {
	{C_X-B_KAN*2-B_SIZE, C_Y-B_POS-B_SIZE,		/* T501 */
	 C_X-B_KAN*2+B_SIZE, C_Y-B_POS+B_SIZE,
	 1, 0x01},
	{C_X-B_KAN-B_SIZE, C_Y-B_POS-B_SIZE,		/* T502 */
	 C_X-B_KAN+B_SIZE, C_Y-B_POS+B_SIZE,
	 1, 0x02},
	{C_X-B_SIZE, C_Y-B_POS-B_SIZE,			/* T503 */
	 C_X+B_SIZE, C_Y-B_POS+B_SIZE,
	 1, 0x04},
	{C_X+B_KAN-B_SIZE, C_Y-B_POS-B_SIZE,		/* T504 */
	 C_X+B_KAN+B_SIZE, C_Y-B_POS+B_SIZE,
	 1, 0x08},
	{C_X+B_KAN*2-B_SIZE, C_Y-B_POS-B_SIZE,		/* T505 */
	 C_X+B_KAN*2+B_SIZE, C_Y-B_POS+B_SIZE,
	 1, 0x10},
	{C_X+B_POS-B_SIZE, C_Y-B_KAN*2-B_SIZE,		/* T506 */
	 C_X+B_POS+B_SIZE, C_Y-B_KAN*2+B_SIZE,
	 1, 0x20},
	{C_X+B_POS-B_SIZE, C_Y-B_KAN-B_SIZE,		/* T507 */
	 C_X+B_POS+B_SIZE, C_Y-B_KAN+B_SIZE,
	 1, 0x40},
	{C_X+B_POS-B_SIZE, C_Y-B_SIZE,			/* T508 */
	 C_X+B_POS+B_SIZE, C_Y+B_SIZE,
	 1, 0x80},
	{C_X+B_POS-B_SIZE, C_Y+B_KAN-B_SIZE,		/* T509 */
	 C_X+B_POS+B_SIZE, C_Y+B_KAN+B_SIZE,
	 0, 0x01},
	{C_X+B_POS-B_SIZE, C_Y+B_KAN*2-B_SIZE,		/* T510 */
	 C_X+B_POS+B_SIZE, C_Y+B_KAN*2+B_SIZE,
	 0, 0x02},
	{C_X+B_KAN*2-B_SIZE, C_Y+B_POS-B_SIZE,		/* T511 */
	 C_X+B_KAN*2+B_SIZE, C_Y+B_POS+B_SIZE,
	 0, 0x04},
	{C_X+B_KAN-B_SIZE, C_Y+B_POS-B_SIZE,		/* T512 */
	 C_X+B_KAN+B_SIZE, C_Y+B_POS+B_SIZE,
	 0, 0x08},
	{C_X-B_SIZE, C_Y+B_POS-B_SIZE,			/* T513 */
	 C_X+B_SIZE, C_Y+B_POS+B_SIZE,
	 0, 0x10},
	{C_X-B_KAN-B_SIZE, C_Y+B_POS-B_SIZE,		/* T514 */
	 C_X-B_KAN+B_SIZE, C_Y+B_POS+B_SIZE,
	 0, 0x20},
	{C_X-B_KAN*2-B_SIZE, C_Y+B_POS-B_SIZE,		/* T515 */
	 C_X-B_KAN*2+B_SIZE, C_Y+B_POS+B_SIZE,
	 0, 0x40},
	{C_X-B_POS-B_SIZE, C_Y+B_KAN*2-B_SIZE,		/* T516 */
	 C_X-B_POS+B_SIZE, C_Y+B_KAN*2+B_SIZE,
	 0, 0x80},
	{C_X-B_POS-B_SIZE, C_Y+B_KAN-B_SIZE,		/* T517 */
	 C_X-B_POS+B_SIZE, C_Y+B_KAN+B_SIZE,
	 3, 0x01},
	{C_X-B_POS-B_SIZE, C_Y-B_SIZE,			/* T518 */
	 C_X-B_POS+B_SIZE, C_Y+B_SIZE,
	 3, 0x02},
	{C_X-B_POS-B_SIZE, C_Y-B_KAN-B_SIZE,		/* T519 */
	 C_X-B_POS+B_SIZE, C_Y-B_KAN+B_SIZE,
	 3, 0x04},
	{C_X-B_POS-B_SIZE, C_Y-B_KAN*2-B_SIZE,		/* T520 */
	 C_X-B_POS+B_SIZE, C_Y-B_KAN*2+B_SIZE,
	 3, 0x08},
	{C_X-B_POS-B_SIZE, C_Y-B_KAN*3-R_SIZE*3-R_KAN,	/* T521 */
	 C_X-B_POS+B_SIZE, C_Y-B_KAN*3-R_SIZE*1-R_KAN,
	 2, 0x80},
	{C_X-B_POS-B_SIZE, C_Y-B_KAN*3-R_SIZE,		/* T522 */
	 C_X-B_POS+B_SIZE, C_Y-B_KAN*3+R_SIZE,
	 2, 0x40},
	{C_X-B_POS-B_SIZE, C_Y+B_KAN*3-R_SIZE,		/* T523 */
	 C_X-B_POS+B_SIZE, C_Y+B_KAN*3+R_SIZE,
	 2, 0x20},
	{C_X-B_POS-B_SIZE, C_Y+B_KAN*3+R_SIZE*1+R_KAN,	/* T524 */
	 C_X-B_POS+B_SIZE, C_Y+B_KAN*3+R_SIZE*3+R_KAN,
	 2, 0x10},
	{C_X+B_POS-B_SIZE, C_Y-B_KAN*3-R_SIZE*3-R_KAN,	/* T525 */
	 C_X+B_POS+B_SIZE, C_Y-B_KAN*3-R_SIZE*1-R_KAN,
	 2, 0x08},
	{C_X+B_POS-B_SIZE, C_Y-B_KAN*3-R_SIZE,		/* T526 */
	 C_X+B_POS+B_SIZE, C_Y-B_KAN*3+R_SIZE,
	 2, 0x04},
	{C_X+B_POS-B_SIZE, C_Y+B_KAN*3-R_SIZE,		/* T527 */
	 C_X+B_POS+B_SIZE, C_Y+B_KAN*3+R_SIZE,
	 2, 0x02},
	{C_X+B_POS-B_SIZE, C_Y+B_KAN*3+R_SIZE*1+R_KAN,	/* T528 */
	 C_X+B_POS+B_SIZE, C_Y+B_KAN*3+R_SIZE*3+R_KAN,
	 2, 0x01},
	{-1}
};

static	void	du(void);
static	void	dsp_lcd(void);
static	void	m_int(union REGS *);
static	void	m_csron(void);
static	void	mousechk(void);
static	int	kbchk(void);
static	void	p_input(void);
static	void	input_bit(int);
static	void	input_debag(void);
static	void	rs1chk(void);
static	void	timechk(void);
static	int	char_to_int(char *, int);

static	char	a[256];
static	char	sbuf[10];
static	char	rbuf[6];
static	int	rcnt;
static	int	p_bit1, p_bit2;
static	int	r_bit1, r_bit2;
static	int	i_bit1, i_bit2;
static	int	c_bit1, c_bit2;
static	int	tflag1;
static	int	tflag2;
static	int	first;

/*=======================================================================
 |
 |		^ctC
 |
 |	static	void	main(void)
 |
 =======================================================================*/
main(void)
{

	RSPRM	rsprm;

	_setvideomode(_98RESS8COLOR);
	_setwritemode(_GPSET);

	if (m_init() == 0) {
		printf("}EXhCogݍŉ");
		getch();
	} else {
		rsprm.sync_mode = ASYNC;
		rsprm.duplex = DUPLEX_FULL;
		rsprm.blt = BLT_9600;
		rsprm.parity = PARITY_ODD;
		rsprm.chr_len = CHR_8;	
		rsprm.stp_len = STP_1;
		rsprm.flow_ctrl = FLOW_NONE;
		rsprm.dtr = DTR_ON;
		rsprm.buf_size = 1024;
		rsprm.bufp = NULL;

		rs1_open(&rsprm);
		tm_open();
		signal(SIGINT, SIG_IGN);

		du();
		rs1_close();
		tm_close();
	}
	_setvideomode(_98TEXT80);
}

/*=======================================================================
 |
 |		^ct̓`FbN
 |
 |	static	void	du(void)
 |
 =======================================================================*/
static	void	du(void)
{
	dsp_lcd();
	printf("\n>");
	m_csron();

	for (;;) {
		mousechk();
		rs1chk();
		timechk();
		if (kbchk())
			break;
	}
}


/*=======================================================================
 |
 |		}EX`FbN
 |
 |	static	void	mousechk(void)
 |
 =======================================================================*/
static	void	mousechk(void)
{
	POS_XY	*beze;	
	int	px, py;
	int	plsw, prsw;
	static	int	sw;
	static	POS_XY	*ptr;

	m_pos(&px, &py, &plsw, &prsw);
	if (plsw != 0 && sw == 0) {		/* {^Fnm */
		for (beze = bezel; beze->x1 != -1; beze++) {
			if ((px >= beze->x1 && px <= beze->x2) && 
			    (py >= beze->y1 && py <= beze->y2)) {
				m_csroff();
				_rectangle(_GFILLINTERIOR,   /* hԂ */
					beze->x1, beze->y1,
					beze->x2, beze->y2);
				m_csron();
				sbuf[beze->byte] |= beze->bit;
				ptr = beze;
				sw = 1;
				break;
			}
		}
	} else if (plsw == 0 && sw == 1) {
		beze = ptr;		
		sbuf[beze->byte] &= ~beze->bit;
		m_csroff();
		_setcolor(0);			/* hԂij */
		_rectangle(_GFILLINTERIOR,
			beze->x1, beze->y1,
			beze->x2, beze->y2);
		_setcolor(7);			/* g\ij */
		_rectangle(_GBORDER,
			beze->x1, beze->y1,
			beze->x2, beze->y2);
		m_csron();
		sw = 0;
	}
}

/*=======================================================================
 |
 |		L[{[h`FbN
 |
 |	static	void	kbchk(void)
 |
 =======================================================================*/
static	int	kbchk(void)
{
	static	int	i;
	int	c, st;

	st = 0;
	if (kbhit()) {
		c = getch();
		if (c == KEY_ESC) {
			i = 0;
			st = 1;
		} else if (c == KEY_CR) {
			a[i] = '\0';	
			p_input();
			rs1_clear();
			i = 0;
		} else {
			putch(c);
			a[i++] = c;
		}
	}
	return(st);
}

/*=======================================================================
 |
 |		L[̓`FbN
 |
 |	static	void	p_input(void)
 |
 =======================================================================*/
static	void	p_input(void)
{
	if ((strcmp(a, "p") == 0) || (strcmp(a, "P") == 0)) {
		printf("\nPOWER ON BIT = ");
		input_bit(1);
	} else if ((strcmp(a, "r") == 0) || (strcmp(a, "R") == 0)) {
		printf("\nR BIT = ");
		input_bit(2);
	} else if ((strcmp(a, "i") == 0) || (strcmp(a, "I") == 0)) {
		printf("\nI BIT = ");
		input_bit(3);
	} else if ((strcmp(a, "c") == 0) || (strcmp(a, "C") == 0)) {
		printf("\nC BIT = ");
		input_bit(4);
	} else if ((strcmp(a, "d") == 0) || (strcmp(a, "D") == 0)) {
		printf("\nDEBAG : ");
		input_debag();
	}
	printf("\n>");
}

/*=======================================================================
 |
 |		͂ahs@Zbg
 |
 |	static	void	input_bit(int)
 |
 =======================================================================*/
static	void	input_bit(int bit_st)
{
	int	bit1, bit2;

	bit1 = bit2 = 0;

	scanf("%2x%2x", &bit1, &bit2);
	rewind(stdin);

	switch	(bit_st) {
		case 1:
			p_bit1 = bit1;
			p_bit2 = bit2;
			break;
		case 2:
			r_bit1 = bit1;
			r_bit2 = bit2;
			break;
		case 3:
			i_bit1 = bit1;
			i_bit2 = bit2;
			break;
		case 4:
			c_bit1 = bit1;
			c_bit2 = bit2;
			break;
	}

	printf("\n>");
	printf("p1:%2X, p2:%2X\n", p_bit1, p_bit2);
	printf(" r1:%2X, r2:%2X\n", r_bit1, r_bit2);
	printf(" i1:%2X, i2:%2X\n", i_bit1, i_bit2);
	printf(" c1:%2X, c2:%2X\n", c_bit1, c_bit2);
}

/*=======================================================================
 |
 |		fobO[h؂ւ
 |
 |	static	void	input_debag(void)
 |
 =======================================================================*/
static	void	input_debag(void)
{
	int	bit1;
	char	c;

	scanf("%1d", &bit1);
	rewind(stdin);
	
	c = sbuf[3];
	switch	(bit1) {
		case 1:
			if (c & 0x10)
				sbuf[3] &= 0xef;
			else
				sbuf[3] |= 0x10;
			break;
		case 2:
			if (c & 0x20)
				sbuf[3] &= 0xdf;
			else
				sbuf[3] |= 0x20;
			break;
	}

	c = sbuf[3];
	c &= 0x10;
	c >>= 4;
	printf("\n>");
	printf("Ӱ1:%2X\n", c);

	c = sbuf[3];
	c &= 0x20;
	c >>= 5;
	printf(" Ӱ2:%2X\n", c);
}

/*=======================================================================
 |
 |		qrQRQb`FbN
 |
 |	static	void	rs1chk(void)
 |
 =======================================================================*/
static	void	rs1chk(void)
{
	char	c;
	int	wk1, wk2;

	if (rs1_rxc()) {
		rbuf[rcnt++] = rs1_get();		/* M */
		if (rcnt == 6) {
			tflag2 = 0;
			tm_stop(1);
			rcnt = 0;
			if (first == 0) {		/* POWER ON BIT */
				sbuf[4] = p_bit1;
				sbuf[5] = p_bit2;
				rs1_sendreq(sbuf, 10);
				printf("\n>MIio@ahsj\n>");
				first = 1;
				return;
			}
			c = rbuf[4];
			if (c & 0x80) {			/* Echo BIT */
				rs1_sendreq(rbuf, 6);
				printf("\n>MIid@ahsj\n>");
			}
			c = rbuf[5];
			if (c & 0x02) {			/* R BIT */
				sbuf[4] = r_bit1;
				sbuf[5] = r_bit2;
				printf("\n>M҂iq@ahsj\n>");
				tm_set(0, 300);		/* ^C}[Zbg */
				tflag1 = 1;
			}
			c = rbuf[5];
			if (c & 0x01) {			/* I BIT */
				sbuf[4] = i_bit1;
				sbuf[5] = i_bit2;
				printf("\n>M҂ih@ahsj\n>");
				tm_set(0, 300);		/* ^C}[Zbg */
				tflag1 = 1;
			} else {
				sbuf[4] = c_bit1;
				sbuf[5] = c_bit2;
				rs1_sendreq(sbuf, 10);	/*  */
//				printf("\n>MIib@ahsj\n>");
			}
		} else {
			tm_set(1, 2);			/* ^C}[Zbg */
			tflag2 = 1;
		}
	}
}

/*=======================================================================
 |
 |		^C}[`FbN
 |
 |	static	void	timechk(void)
 |
 =======================================================================*/
static	void	timechk(void)
{
	if (tflag1 == 1) {
		if (tm_check(0)) {		/* ^CAEg */
			rs1_sendreq(sbuf, 10);
			printf("\n>MI\n>");
			tflag1 = 0;
		}
	}
	if (tflag2 == 1) {
		if (tm_check(1)) {		/* ^CAEg */
			rcnt = 0;		
			rs1_clear();
//			printf("\n>qate@Zbg\n>");
			tflag2 = 0;
		}
	}
}

/*=======================================================================
 |
 |		ctʃC[W\
 |
 |	static	void	dsp_lcd(void)
 |
 =======================================================================*/
static	void	dsp_lcd(void)
{
	POS_XY	*beze;	

	_rectangle(_GBORDER,			/* DU */
		C_X-D_SIZE/2, C_Y+D_SIZE/2,
	 	C_X+D_SIZE/2, C_Y-D_SIZE/2);

	beze = bezel;
	while (beze->x1 != -1) {
		_rectangle(_GBORDER,		/* bezel switch */
			beze->x1, beze->y1,
			beze->x2, beze->y2);
		beze++;
	}
}

/*=======================================================================
 |
 |		}EXhCo[Ăяo
 |
 |	void	m_int(reg)
 |
 |		union REGS *reg;	WX^
 |
 =======================================================================*/
static
void	m_int(union REGS *reg)
{
	int86(0x33, reg, reg);
}

/*=======================================================================
 |
 |		}EXhCo[
 |
 |	int	m_init()
 |
 |		int	c;		\
 |
 |		Ԓl			OFhCoȂ@PF
 |
 =======================================================================*/
int	m_init(void)
{
	union	REGS	reg;

	reg.x.ax = 0;
	m_int(&reg);
	
	return (reg.x.ax);
}

/*=======================================================================
 |
 |		}EXJ[\\nm
 |
 |	void	m_csron()
 |
 =======================================================================*/
void	m_csron(void)
{
	union	REGS	reg;

//	if (m_csr_flag == 0) {
		reg.x.ax = 1;
		m_int(&reg);

//		m_csr_flag = 1;
//	}
}

/*=======================================================================
 |
 |		}EXJ[\\nee
 |
 |	void	m_csroff()
 |
 =======================================================================*/
void	m_csroff(void)
{
	union	REGS	reg;

//	if (m_csr_flag != 0) {
		reg.x.ax = 2;
		m_int(&reg);

//		m_csr_flag = 0;
//	}
}

/*=======================================================================
 |
 |		}EXJ[\̈ʒu𓾂
 |
 |	void	m_pos(px, py, plsw, prsw)
 |
 |		int	*px;		}EXJ[\̂wW
 |		int	*py;		}EXJ[\̂xW
 |		int	*plsw;      	{^̏
 |		int	*prsw;      	E{^̏
 |
 =======================================================================*/
void	m_pos(int *px, int *py, int *plsw, int *prsw)
{
	union	REGS	reg;

	reg.x.ax = 3;
	m_int(&reg);

	*px = reg.x.cx;
	*py = reg.x.dx;
	*plsw = reg.x.ax;
	*prsw = reg.x.bx;
//	if (mouse_drv) {
		*plsw = (*prsw & 0x01) ? -1 : 0;
		*prsw = (*prsw & 0x02) ? -1 : 0;
//	}
}
